#
# pngGraph.py
#
# Copyright (C) 2010 Tim Wentzlau
#
# This file is part of the XBMC Weather Station script
# 
# The Weather Station script is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# XBMC Weather station script is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with EventGhost; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import os,pngCanvas
from skimpyGimpy import canvas

fontPath=os.path.dirname(os.path.realpath(__file__))+"\\skimpyGimpy\\fonts\\mlmfonts\\"
print fontPath

class PNGGraph:
	width=100
	height=100
	graphHeight=80
	graphWidth=80
	graphOffsetX=20
	graphOffsetY=20
	captionHeight=30
	xName="X"
	yName="Y"
	xMin=0
	xMax=100
	xTick=10
	yMin=2000000000
	yMax=-2000000000
		
	yTick=100
	offsetY=0
	offsetX=0
	title="myGraph"
	dataSets=[]
	def __init__(self,canvasWidth,canvasHeight):
		self.graphCanvas = canvas.Canvas()
		self.graphCanvas.addFont("propell", fontPath+"propell.bdf")
		self.graphCanvas.setFont("propell", .7)
		self.graphCanvas.setColor(99,99,0xff)
		
		
		
		self.captionHeight=0
		axisHeight=20
		axisWidth=190
		self.width=canvasWidth
		self.height=canvasHeight
		self.graphHeight=self.height-self.captionHeight-axisHeight
		self.graphWidth=self.width-2*axisWidth
		self.offsetX=axisWidth
		self.offsetY=axisHeight
		self.dataSets=[]
	 
	def setTitle(self,title):
		self.title=title
	def scaleXName(self,name):
		self.self.xName=name
	def scaleYName(sef,name):
		self.yName=name
	def xScaleDef(self,offset,tick):
		self.xMin=offset
		self.xTick=tick
	def yScaleDef(self,tick):
		self.yTick=tick
	def addDataSet(self,data):
		from math import ceil, floor
		
		self.dataSets.append(data)
		setSize=0
		for dat in data:
			d=dat[1]
			setSize=setSize+1;
			if d<self.yMin:
				self.yMin=d
			if d>self.yMax:
				self.yMax=d
		ymax=round(self.yMax)
		if ymax<self.yMax:
			ymax=ymax+1
		if ymax==0:
			ymax=1
		
		self.yMax=ymax
		self.yMin=floor(self.yMin)
		self.xTick=self.graphWidth/(setSize-1)		
		self.yTick=self.graphHeight/(self.yMax)
		
		if (self.yMax-self.yMin)==0:
			self.yTick=1
		else:
			self.yTick=self.graphHeight/(self.yMax-self.yMin)
		self.yTickCount=self.graphHeight/self.yTick
		
	def calcYScale(self):
		span=self.yMax-self.yMin
		if span<10:
			scale=1
		elif span<20:
			scale=5
		elif span<100:
			scale=10
		else:
			scale=100
			
		self.yScale=scale	
		
	def getCanvas(self):
		return self.graphCanvas
		
	def getOffsetX(self):
		return self.offsetX
		
	def getOffsetY(self):
		return self.offsetY
		
	def getXTick(self):
		return self.xTick
	
	def getGraphHeight(self):
		return self.graphHeight
	
	def create(self,filePath):
		from math import ceil, floor
		
		self.graphCanvas.crop(0,0, self.width,self.height)
		self.graphCanvas.setColor(99,99,0xff)
		self.graphCanvas.addText(10,self.height-self.captionHeight+5, self.title)
		self.graphCanvas.setCap(0)
		self.graphCanvas.setWidth(0.1)

		
		
			
		
		if (self.yMin<0):
			yOffset=self.offsetY-self.yMin*self.yTick
			self.graphCanvas.addLine((self.offsetX,yOffset),(self.offsetX+self.graphWidth,yOffset))
		
		self.graphCanvas.addLine((self.offsetX,self.offsetY),(self.offsetX+self.graphWidth,self.offsetY))
		self.graphCanvas.addLine((self.offsetX,self.offsetY),(self.offsetX,self.height))
	
		self.calcYScale()
		ystep=self.graphHeight/(self.yScale*self.yTick)
		fh=12
		steps=self.graphHeight/fh
		span=self.yMax-self.yMin
		ystep=ceil(span/steps)
		steps=span/ystep
		fh=self.graphHeight/steps
		
		y=0
		ytxt=self.yMin
		while y<self.graphHeight:
			self.graphCanvas.rightJustifyText(self.offsetX-5,self.offsetY+y-3,str(ytxt))
			y=y+fh
			ytxt=ytxt+ystep
			
		
		x=0
		xstep=self.graphWidth/50
		xstep=len(self.dataSets[0])/xstep
		while x<len(self.dataSets[0]):
			set=self.dataSets[0]
			d=set[x]
			t=d[0]
			self.graphCanvas.centerText(self.offsetX+x*self.xTick,2, t)
			x=x+xstep
		
		t=0
		s=0
		for set in self.dataSets:
			s=s+1
			if s==1:
				self.graphCanvas.setColor(0,0xff,0)
			elif s==2:
				self.graphCanvas.setColor(0xff,0,0)
			elif s==3:
				self.graphCanvas.setColor(0xff,0xff,0)
		
			
			cp=[0,0]
			x=0
			for d in set:
				t=d[0]
				y=d[1]
				if x==0:
					cy=y
				else:
					self.graphCanvas.addLine(((x-1)*self.xTick+self.offsetX,self.offsetY+((cy-self.yMin)*self.yTick)),(x*self.xTick+self.offsetX,self.offsetY+((y-self.yMin)*self.yTick)))
				cy=y
				x=x+1
		
		
		
		#self.graphCanvas.rotate(90)
		self.graphCanvas.setFont("propell", 1)
		self.graphCanvas.setColor(0,0xff,0)
		#self.graphCanvas.centerText(self.height/2,-10,self.title)
		self.graphCanvas.addText(10,self.height-20,self.title)
		self.graphCanvas.dumpToPNG(filePath)
